/*
 * Point3D.java:
 *
 * Copyright (C) 2000 John Watson, jwatson@tempusmud.com
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */
import java.awt.*;

public class Point3D extends Point {
        
        public int z = 0;
        
        public Point getPoint() {
                return this;
        }

        public boolean equals( Object o ) {

                if ( o == this )
                        return true;
                
                if ( o instanceof Point3D ) {
                        Point3D ot = (Point3D) o;
                        if ( x == ot.x && y == ot.y && z == ot.z )
                                return true;
                        return false;
                }

                return super.equals( o );
        }

        public Point3D( int ax, int ay, int az ) {
                super( ax, ay );
                this.z = az;
        }

        public Point3D() {
        }

        public Point3D( Point p ) {
                super( p );
        }

        public void setLocation( Point3D other ) {
                setLocation( other.x, other.y, other.z );
        }

        public void setLocation( int ox, int oy, int oz ) {
                x = ox;
                y = oy;
                z = oz;
        }

        public void add( Point3D other ) {
                x += other.x;
                y += other.y;
                z += other.z;
        }

        public void divide( double divisor ) {
                x /= divisor;
                y /= divisor;
                z /= divisor;
        }

        public void multiply( double factor ) {
                x *= factor;
                y *= factor;
                z *= factor;
        }
                
}
        
