import java.io.*;
import java.util.*;

public class Script implements Serializable {

        public static final long serialVersionUID = 0;

        public static class Command implements Serializable {

                public static final long serialVersionUID = 0;

                private static byte blah = 0;

                static final byte NONE             = blah++;
                static final byte CENTERPRINT      = blah++;
                static final byte CAMERA_MODE      = blah++;
                static final byte ROTATE_CAMERA    = blah++;
                static final byte ZOOM_CAMERA      = blah++;
                static final byte SET_CAMERA_ANGLE = blah++;
                static final byte SET_CAMERA_ZOOM  = blah++;
                static final byte ROTATE_PLAYER    = blah++;
                static final byte SET_PLAYER_ANGLE = blah++;
                static final byte PLAYER_WALK      = blah++;
                static final byte WAIT             = blah++;
                static final byte TRIGGER_DOOR     = blah++;
                static final byte TELEPORT         = blah++;
                static final byte SPAWN_SECT       = blah++;
                static final byte WAKE_MONSTER     = blah++;
                static final byte LIGHT            = blah++;
                static final byte SOUND            = blah++;
                static final byte LOOP             = blah++;
                static final byte ALLOW_CONTROL    = blah++;
                static final byte CHECK_KEY        = blah++;
                static final byte TERMINATE        = blah++;
                static final byte CHANGE_MAP       = blah++;
                
                static final byte NUM_TYPES        = blah;
                
                static final String[] typenames = new String[] {
                        "None",
                        "Centerprint",
                        "Camera Mode",
                        "Rotate Camera",
                        "Zoom Camera",
                        "Camera Angle",
                        "Camera Zoom",
                        "Rotate Entity",
                        "Entity Angle",
                        "Walk Entity",
                        "Wait",
                        "Trigger Door",
                        "Teleport",
                        "Spawn Sector",
                        "Wake Monster",
                        "Light",
                        "Sound",
                        "Loop",
                        "Allow Control",
                        "Check Key",
                        "Terminate",
                        "Change Map",
                };

                static final String[][] valuenames = new String[][] {
                        { null, null, null, null },
                        { "Message Number", "Duration", null, null },
                        { "Camera Mode", null, null, null },
                        { "x", "y", "z", null },
                        { "zoom increment", null, null, null },
                        { "x", "y", "z", null },
                        { "zoom factor", null, null, null },
                        { "x", "y", "z", null },
                        { "x", "y", "z", null }, 
                        { "x", "y", "z", null },
                        { "milliseconds", null, null, null },
                        { "tag num", "iterations", null, null },
                        { null, null, null, null },
                        { null, null, null, null },
                        { null, null, null, null },
                        { null, null, null, null },
                        { null, null, null, null },
                        { "iterations", "command span", null, null },
                        { "true/false", null, null, null },
                        { "key item vnum", "success cmd jmp", null, null },
                        { null, null, null, null },
                        { "mapname index", "startpoint number", null, null },
                };

                static {
                        if ( typenames.length != valuenames.length )
                                System.out.println( " :: Programmer error: Script.Command" );
                }

                byte type;
                short[] values = new short[4];
                
                Command() {}

                void export( DataOutputStream dos ) throws IOException {
                        dos.writeByte( type );
                        for ( int i = 0; i < 4; ++i )
                                dos.writeShort( values[i] );
                }

                Command( DataInputStream dis ) throws IOException {
                        type = dis.readByte();
                        for ( int i = 0; i < 4; ++i )
                                values[i] = dis.readShort();
                }
        };

        int num = 0;

        Vector msgs  = new Vector();
        Vector cmds = new Vector();

        void export( DataOutputStream dos ) throws IOException {
                
                dos.writeByte( cmds.size() );
                dos.writeByte( msgs.size() );
                
                for ( Iterator iter = cmds.iterator(); 
                      iter.hasNext(); ) {
                        ( (Command) iter.next() ).export( dos );
                }
                
                for ( Iterator iter = msgs.iterator(); iter.hasNext(); ) {
                        String s = (String) iter.next();
                        byte[] buf = s.getBytes();
                        
                        dos.writeShort( buf.length );
                        dos.write( buf, 0, buf.length );
                }
        }

        Script( DataInputStream dis ) throws IOException {
                cmds.setSize( dis.readByte() );
                msgs.setSize( dis.readByte() );

                for ( int i = 0; i < cmds.size(); ++i ) {
                        cmds.set( i, new Command( dis ) );
                }

                for ( int i = 0; i < msgs.size(); ++i ) {
                        int len = dis.readShort();
                        byte[] buf = new byte[ len ];

                        String s = null;
                        
                        if ( len > 0 && dis.read( buf, 0, len ) == len )
                                s = new String( buf );

                        msgs.set( i, s );
                }
        }

        Script( int anum ) {
                num = anum;
        }
}
