import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class ToolsMenu extends JMenu {

        private Editor _editor = null;

        private JMenuItem _texCheckItem = new JMenuItem( "Texture Check" );
        private JMenuItem _scriptItem   = new JMenuItem( "Scripts" );
        
        public ToolsMenu( Editor editor ) {
                super( "Tools" );
                _editor = editor;
                add( _texCheckItem );
                add( _scriptItem );

                _texCheckItem.addActionListener( new ActionListener() {
                                public void actionPerformed( ActionEvent evt ) {
                                        JFrame frame = new JFrame( "Texture Checker - " + _editor.getMap().name );
                                        Container c = frame.getContentPane();
                                        c.setLayout( new BorderLayout() );
                                        c.add( new TextureChecker( _editor.getMap() ), "Center" );
                                        frame.pack();

                                        Editor.centerFrame( frame );

                                        frame.show();
                                }
                        } );

                _scriptItem.addActionListener( new ActionListener() {
                                public void actionPerformed( ActionEvent evt ) {
                                        JFrame frame = new JFrame( "Script Editor - " + _editor.getMap().name );
                                        Container c = frame.getContentPane();
                                        c.setLayout( new BorderLayout() );
                                        c.add( new ScriptEditor( _editor.getMap() ), "Center" );
                                        frame.pack();

                                        Editor.centerFrame( frame );

                                        frame.show();    
                                }
                        } );
        }
}
        
